Add agile features (like formerly provided by XPlanner) to Redmine
Description

Hello Philippe,

I will use this opportunity to say : great project :)

I would like to suggest a possible feature, which | think is very useful.

Please have a look at the project XPlanner (http://www.xplanner.org/). | think it will be very useful to have an XP
functionality in Redmine, the possibility to group trackers in stories and stories in iterations(versions). The labels

of this groups is not important(should be configurable), what's important is to group all the trackers - bugs, new features
to a specific customer request(stories) and to a specific version.

We use XPlanner for project management and even if we don't follow XP rules 100%, it is still very useful to organize
the project based on XP philosophies.

I think you could "borrow" some of the XPlanner features :) and some of the XPlanner users :)
Thanks.

PS : Any opinions?

Related issues:

Related to Redmine - Feature #397: "User Story" Agile concept support New
History

#1 - 2007-09-23 16:43 - Jean-Philippe Lang

Hi,

Couldn't you create a tracker called 'Story' and use issue relations
to group features, bugs inside stories ?

#2 - 2007-09-25 09:46 - Adrian Tarau
I'm not sure where to create a tracker 'Story' :)
Feature Requests is not the right place?

#3 - 2007-09-25 12:19 - Jean-Philippe Lang

You can create a 'Story' tracker in Redmine by going to:
'Admin -> Issue tracking -> Trackers' and click 'New
tracker'

(you need to log in as administrator).

After that, you can define workflows for this tracker in 'Admin
-> |ssue tracking -> Wokflow'

#4 - 2007-09-25 16:52 - Adrian Tarau
No, is not the same.

Let me explain. Right now in Redmine you can create trackers
- which are just types of activities. This is fine.

You can create a new issue with a specific tracker and you
http://www.xplanner.org/

can specify the version, category, etc. Everything is
related to a project.

In XP meteorology, you have

- Project

- Iteration(version)

- Story (feature from user perspective - what the user
wants)

- Tasks - (Redmine = trackers)

Right now XPlanner doesn't support multiple task types,
actually it has some types, but is not flexible as in Redmine.

So basically, when you insert a task(tracker) you already
know the version and the feature(a group of functionalities
from the user perspective). When you have a bug related to a
feature you just add it to the right Story, and you can

track time spent to develop the feature and fix bugs(in case
of Redmine - you can split the time per trackers)

I'm not saying the current approach is not good. But | think
the XP approach is also a good one, even if you don't follow
all the rules.

And of course, it is easy to move features from version to
version, continue stories in the next version - if it didn't
make it on time for the current version and so on.

Thanks.

#5 - 2008-02-03 11:22 - Jean-Philippe Lang

- Subject changed from XPlanner &amp;amp; Redmine to XPlanner & Redmine

#6 - 2008-10-09 22:40 - Melissa Bitner

We're also using agile development and some features to manage iterations would be really nice. | created a custom field to store the name of the
iteration that an issue was assigned to but we have multiple projects and there's no way to see all issues for a given iteration. What would be ideal is
to be able to create an iteration, name it, give it a start and end date, and assign issues to it. Some basic reporting would make it even better -
estimated hours, percent complete, and that sort of thing.

#7 - 2008-12-02 21:11 - Elliot Lee

Here are some specific changes in Redmine that would make it easier to use for Agile processes, without disrupting the many other ways that it can
be used:

. The ability for each Redmine user to provide information on how many hours they will be available to work each day. One good way to do this might
be to allow them to specify their working hours and days for a typical week, and then also allow them to edit the calendar for any one date (to deal
with holidays and such).

. The ability to automatically calculate how many hours an issue will take, including dependencies.

. The ability to automatically calculate the end date of an issue, based on the start date, estimated hours remaining, the availability of the assigned
developer, and also the end dates of any other issues that the issue in question depends on.

#8 - 2008-12-02 21:57 - Elliot Lee

Elliot Lee wrote:

Here are some specific changes in Redmine that would make it easier to use for Agile processes, without disrupting the many other ways that it
can be used:

And a few more ideas:

. A way to track the projected completion time of a set of issues over time. In other words, tracking how many hours were remaining to be done on a
task at any point in time, and allowing that to be displayed on a nice chart of projected versus actual hours remaining (which in Agile land is called a
burn-down chart).

. An easy way to re-order stories (err, issues :). Priority is not sufficient because it only has five levels of granularity. One could add a custom field
called 'Sort order', but it's cumbersome to manually go in and edit this field on two issues when all one really one wants to do is swap their position.

. An easy way to wiki-link to the list, calendar, and gantt views for specific custom queries.

. A way to have queries display as a tree, which would be somewhat similar to list view, but also displaying the "children" of an issue (which would be
the issues that 'block’ or 'precede’ the parents).

If you want more ideas, XPlanner looks interesting, and Rally Software (rallydev.com) has free demos of a system that is really nice for this. | guess it
all depends how much time you care to invest in this area. :)
#9 - 2008-12-03 08:57 - Markus Knittig

XPlanner and Rally are specific software for managing agile prozesses. Redmine is not. But most of your ideas could be implemented in a plugin.

#10 - 2008-12-03 23:38 - Elliot Lee

Markus, you are correct, that Redmine is not Agile-specific. The problem with using XPlanner and Rally is that they lack all the great features of
Redmine. They are only for Agile project management. Having one integrated system that can accommodate everything from source watching to
issue tracking to wiki to project management would be so much more valuable than having four different software packages to do that. The idea of
Redmine replacing some/most of XPlanner's and Rally's functionality is what's being suggested here and in issue #397.
It would be helpful to know which ideas could be implemented as plugins and which would require core redmine changes...
#11 - 2008-12-10 01:51 - Eric Davis
Elliot Lee wrote:

It would be helpful to know which ideas could be implemented as plugins and which would require core redmine changes...

Because of Ruby, I'm finding just about everything can be done in a plugin. Some are more difficult than others, but a lot can be done with the
existing system.

#12 - 2023-11-28 08:57-C S

Since the xplanner project no longer exists (website closed), this issue can probably be closed...

#13 - 2023-11-30 03:58 - Mischa The Evil

- Subject changed from XPlanner & Redmine to Add agile features (like formerly provided by XPlanner) to Redmine

C S wrote in #note-12:

Since the xplanner project no longer exists (website closed), this issue can probably be closed...

Not exactly. This issue is a request to add specific agile project management features (like provided formerly by XPlanner) to Redmine.

#14 - 2023-11-30 03:58 - Mischa The Evil
- Related to Feature #397: "User Story" Agile concept support added
